//******************************************************************************
//      USB ERROR CODE
//******************************************************************************
#ifndef	_XUSBERR_H
#define	_XUSBERR_H
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//
#define FACILITY_USB_ERROR_CODE          0x10

#define	USBERR_BASE	0x4000
#define	ERR(e)	(0xe0100000 + USBERR_BASE + (e))

#define	NORMAL				0
#define	ERROR				0x80000000
//******************************************************************************
//      ammsusb error codes
//******************************************************************************
#define	NOERROR				0

#define	ERR_INVALIDPARAM		ERR(1)
#define	ERR_REGOUTOFRANGE		ERR(2)
#define	ERR_TRANSFER_SIZE_TOO_LONG	ERR(3)

#define	ERR_USB_NO_PIPE_EXISTS		ERR(4)
#define	ERR_SIZEALIGNMENTERROR		ERR(5)	// WRITE_REGS ŃTCYsizeof(WRITEREG)̔{ɂȂĂȂ

#define	ERR_DEVICE_TIMEOUT		ERR(6)
#define	ERR_CANNOT_EXEC_MODULE		ERR(7)
#define	ERR_SYNC_TIMEOUT		ERR(8)
#endif
