//******************************************************************************
//      main program
//******************************************************************************
#include "../../include/usb.h"
#include "../../include/xusberr.h"
#include "c55x_regs.h"
#include "DSP_ADC.h"
#include "dsk5509.h"
#include "dsk5509_led.h"
#include "dsk5509_dip.h"
//******************************************************************************
//      static storage
//******************************************************************************

#define	ADCBUFLEN	2048
#pragma DATA_SECTION(AdcBuf,"gBufUSB");
USHORT	AdcBuf[2][ADCBUFLEN];	// 4KB x 2
USHORT	Command[64];
ULONG	Status;			// ɃXe[^X݂܂B

LOCAL	USHORT	BufSel;
LOCAL	USHORT	BufInx;
USHORT	CommandState;
LOCAL	USHORT	Flag;

// for command test
LOCAL	USHORT	AdWidth;
LOCAL	USHORT	AdSamples;
/*LOCAL	USHORT	AdNWords;*/
#pragma DATA_SECTION (gBufADC, "gBuf1");       // ZNV̒`
#pragma DATA_SECTION (gBufFilter, "gBuf1");       // ZNV̒`
#pragma DATA_SECTION (iir_delaybuf,"gBuf1");

unsigned long gBufADC[2][DMA_BUF_SIZE];
unsigned long gBufFilter[2][DMA_BUF_SIZE];
//unsigned long gBuftest1[DMA_BUF_SIZE],gBuftest2[DMA_BUF_SIZE];
unsigned long gBufUnderSamp[DMA_BUF_SIZE/2];
unsigned long iir_delaybuf[NBIQ*2+2];

unsigned int src_indx=0;
unsigned int gPointerBufADC=NONE;
unsigned int old_dipswitch,current_dipswitch;

unsigned int TransferDataSize,CopyBufSize;
extern long iir_coff8[NBIQ*5],iir_coff9[NBIQ*5],iir_coff_a[NBIQ*5],iir_coff_b[NBIQ*5];

//******************************************************************************
//      external/forward functions
//******************************************************************************
LOCAL	void	command_interpret(ULONG len);
void	SetResponse(ULONG status,ULONG error);
BOOL	SetAccessNotify(ULONG addr,void (*func)(ULONG));
void	SetUsbInitCallBack(void (*func)());
LOCAL	void	accAdcBuf0(ULONG len);
LOCAL	void	accAdcBuf1(ULONG len);
void getdata(unsigned int );

void copy_AD_USBbuf(unsigned short,unsigned short);


//******************************************************************************
//      main 
//      eytF̏ݒȂ
//******************************************************************************
void	main()
{
	unsigned int i;

	BufSel = 0;
	BufInx = 0;
	CommandState = 0;

	/* DSK{[h̃fBbvXCb`S2LED_𐧌䂷邽߂̏ */
	DSK5509_init();
	DSK5509_LED_init();
	DSK5509_DIP_init();

	/* fBbvXCb`S2Read */
	current_dipswitch=DSK5509_rget(DSK5509_USER_REG)>>4;
	old_dipswitch=current_dipswitch;

	/* PLL̏ݒAU12MHz192MHzɒ{ */
	pll_init();

	/* McBSP1SPI}X^[hɐݒ肵ADS1271ɐڑ */
	/* ł͂܂McBSP1̑MEMH̓Zbĝ܂܂Ƃ */
	/* ׂĂ̏Ă瑗MEMH̃Zbg */
	spi_init();

	/* DMȀ */
	/* SPȊMƎMp2chDMAg */
	dma_init();

	/* obt@̃NA */
	for (i=0; i<DMA_BUF_SIZE; i++) {
		gBufADC[0][i] = 0;
		gBufADC[1][i] = 0;
		gBufFilter[0][i]=0;
		gBufFilter[1][i]=0;
		}
/*	for (i=0; i<DMA_BUF_SIZE/4; i++) {
		gBuftest1[i]                 =(long)0x1000000;
		gBuftest1[DMA_BUF_SIZE/4+i]  =(long)0x7000000;
		gBuftest1[DMA_BUF_SIZE/4*2+i]=(long)0x1000000;
		gBuftest1[DMA_BUF_SIZE/4*3+i]=(long)0x7000000;
		gBuftest2[i]                 =(long)0x1000000;
		gBuftest2[DMA_BUF_SIZE/4+i]  =(long)0x7000000;
		gBuftest2[DMA_BUF_SIZE/4*2+i]=(long)0x1000000;
		gBuftest2[DMA_BUF_SIZE/4*3+i]=(long)0x7000000;
	}*/
	for(i=0;i<(NBIQ*2+2);i++){
		iir_delaybuf[i]=0;
	}

	/* 荞݂̏ */
	/* ܂͊荞݃xN^̔zuʒu0x100Ԓnł邱Ƃ */
	/* DSPRAɓ` */
  	IVPD  = 0x0001;
  	IVPH  = 0x0001;

	/* ɃCl[uɂ銄荞݂USBDMA0̂Qɂ */
  	IFR0 |= USB_FLAG;                     
	IFR1 |= DMA0_FLAG;
  	IER0 = USB_FLAG;                     
	IER1= DMA0_FLAG;

	/* 荞݃VXê̂Cl[uɂ */
	/* iLAPIDSPCurts55x.libŒ`Ăj */
  	_enable_interrupts();                    


	/* ()VEGWjAOaɐ삢USBhCo */
	/* usblib.lib̂߂̏ */
	/* usblib.lib̃\[XR[h͔Jł */
	UsbInit();
	UsbSyncSet(0,SYNC_SET);
	UsbSyncSet(1,SYNC_SET);
	SetAccessNotify((ULONG)Command,command_interpret);	// obt@Commandɏ݂Ƃcommand_interpretĂ΂܂
	SetAccessNotify((ULONG)(&AdcBuf[0][0]),accAdcBuf0);
	SetAccessNotify((ULONG)(&AdcBuf[1][0]),accAdcBuf1);

	Status = 0;

	/* ׂĂ̏ł̂McBSP1iSPI[hɐݒj */
	/* ̑MEMH̃ZbgOFFɂADC̃f[^荞݊Jn */
	/* MHƃNbNH̃ZbgOFF */
	SPCR21 |= 0x00c1;
	/* MH̃ZbgOFF */
	SPCR11 |= 0x0001;

	/* [v */
	/* ADC̃f[^荞DMÃobt@32i */
	/* 16ADC̃f[^܂_ */
	/* FIRST_HALFSECOND_HALF̃tOONɂȂ̂ */
	/* ̃tOfBW^tB^Ȃǂ̏ */
	/* sAUSB] */
	while(1){
		if(gPointerBufADC==FIRST_HALF){
			getdata(0);
			gPointerBufADC=NONE;
		}
		else if(gPointerBufADC==SECOND_HALF){
			getdata(1);
			gPointerBufADC=NONE;
		}
	}
}


//******************************************************************************
//      getdata 
//      ADC̃f[^16܂_Call
//		fBbvXCb`S2̒lǂݍ݁AfBW^tB^̏Call
//		PCf[^]̗vꍇɂ́AUSBhCoɃf[^n߂
//		֐copy_AD_USBbufCall
//******************************************************************************
void getdata(unsigned int SelectCh){
	unsigned int i;
			old_dipswitch=current_dipswitch;
			current_dipswitch=DSK5509_rget(DSK5509_USER_REG)>>4;
			/* fBbvXCb`̒lɕύXꍇ́Aԃobt@ */
			/* łiir_delaybuf̒NAɂ */
			if(old_dipswitch!=current_dipswitch){
				for(i=0;i<(NBIQ*2+2);i++){
					iir_delaybuf[i]=0;
				}
			}

			//fBbvXCb`̒lǂݍ݁A̒lɑΉtB^Ww
			//fBbvXCb`̒l8ł΃tB^͌Ă΂Af[^Rs[̂
			if(current_dipswitch>=0x8){		// IIR filter ON
				switch(current_dipswitch){
				case 0x8:
					    iir32(gBufADC[SelectCh], iir_coff8, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE);
					    //iir32(gBuftest1, iir_coff8, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE);
							// x	: input vector
							// h	: cofficient vector
							// r	: output vector
							// dp	: delay line buffer
							// NBIQ	: number of Biquad
							// NX	: number of input/output data (x[NX],r[NX])
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE);
						}
						break;
				case 0x9:
					    iir32(gBufADC[SelectCh], iir_coff9, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE);
					    //iir32(gBuftest1, iir_coff9, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE);
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE);
						}
						break;
				case 0x0a:
						for(i=0;i<DMA_BUF_SIZE/2;i++){
							gBufUnderSamp[i]=gBufADC[SelectCh][2*i];
						}
					    iir32(gBufUnderSamp, iir_coff_a, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE/2);
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE/2);
						}
						break;
				case 0x0b:
						for(i=0;i<DMA_BUF_SIZE/2;i++){
							gBufUnderSamp[i]=gBufADC[SelectCh][2*i];
						}
					    iir32(gBufUnderSamp, iir_coff_b, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE/2);
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE/2);
						}
						break;
				default:
					    iir32(gBufADC[SelectCh], iir_coff8, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE);
					    //iir32(gBuftest1, iir_coff8, gBufFilter[SelectCh], iir_delaybuf, NBIQ, DMA_BUF_SIZE);
							// x	: input vector
							// h	: cofficient vector
							// r	: output vector
							// dp	: delay line buffer
							// NBIQ	: number of Biquad
							// NX	: number of input/output data (x[NX],r[NX])
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE);
						}
						break;
				}
			}
			else{		// IIR filter off
				if(current_dipswitch<0x4){		//100kHz sampling
						for(i=0;i<DMA_BUF_SIZE;i++){
							gBufFilter[SelectCh][i]=gBufADC[SelectCh][i];
							//gBufFilter[SelectCh][i]=gBuftest1[i];
							//gBufFilter[SelectCh][i]=0x10000000+i*0x1000;
							//asm(" RPT #400\n NOP\n ");
						}
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE);
						}
				}
				else{							//50kHz under sampling
						for(i=0;i<DMA_BUF_SIZE/2;i++){
							gBufFilter[SelectCh][i]=gBufADC[SelectCh][2*i];
						}
						if(CommandState==1){
							copy_AD_USBbuf(SelectCh,DMA_BUF_SIZE/2);
						}
				}
			}


}


//******************************************************************************
//      copy_AD_USBbuf 
//      PCUSBŃf[^]̃NGXgꍇCall
//		ADC24rbgf[^DSP̓32rbgLongƂ
//		i[Ă邪Å֐16rbg̃24rbgf[^
//		lߍށB2048Byteł_USBhCoɓn
// 		LEFT_JUSTFY=1ł24rbgf[^͍l߂Ă̂ŁA24rbgA
//		LEFT_JUSTFY=0ł24rbgf[^͉El߂Ă̂ŁA24rbg
//		荞
//******************************************************************************
void copy_AD_USBbuf(unsigned short gFilIndex,unsigned short UsbbufCopySize){
	unsigned int i;

	//USBp̃obt@ɃRs[ADl̐
	if(AdSamples>UsbbufCopySize){		
		TransferDataSize=UsbbufCopySize;
		AdSamples-=UsbbufCopySize;
	}
	else{
		TransferDataSize=AdSamples;
		AdSamples=0;
	}


	//CopyBufSizeUSBp̃obt@ɃRs[鐔
	CopyBufSize=(TransferDataSize*AdWidth+1)/2;

	i=0;
	//while((BufSel<ADCBUFLEN)&&(i<CopyBufSize)){
	while((BufInx<ADCBUFLEN)&&(i<CopyBufSize)){
		switch(i%3){
#if LEFT_JUSTFY
			case 0:
					AdcBuf[BufSel][BufInx++] = (USHORT)(gBufFilter[gFilIndex][i/3*2]>>16);
					break;
			case 1:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2]) &0x0000ff00)
												+(USHORT)(gBufFilter[gFilIndex][i/3*2+1]>>24);
					break;
			case 2:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2+1]>>8)& 0x0000ffff);
					break;
			default:
					break;
#else
			case 0:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2]>>8)& 0x0000ffff);
					break;
			case 1:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2]<<8) &0x0000ff00)
												+(USHORT)((gBufFilter[gFilIndex][i/3*2+1]>>16)&0x000000ff);
					break;
			case 2:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2+1])& 0x0000ffff);
					break;
			default:
					break;
#endif
		}
		i++;

	}

	if(BufInx >= ADCBUFLEN){		// _uobt@̑s܂B
		Flag &= ~(1 << BufSel);
		UsbSyncSet(BufSel,SYNC_RESET);
		BufSel ^= 1;
		BufInx = 0;
		UsbSyncSet(BufSel,SYNC_SET);
		if((Flag & (1 << BufSel)) == 0)
			Status |= 1;		// obt@A_[N܂


		while(i<CopyBufSize){
			switch(i%3){
#if LEFT_JUSTFY
				case 0:
						AdcBuf[BufSel][BufInx++] = (USHORT)(gBufFilter[gFilIndex][i/3*2]>>16);
						break;
				case 1:
						AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2]) &0x0000ff00)
													+(USHORT)(gBufFilter[gFilIndex][i/3*2+1]>>24);
						break;
				case 2:
						AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2+1]>>8)& 0x0000ffff);
						break;
				default:
						break;
#else
			case 0:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2]>>8)& 0x0000ffff);
					break;
			case 1:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2]<<8) &0x0000ff00)
												+(USHORT)((gBufFilter[gFilIndex][i/3*2+1]>>16)&0x000000ff);
					break;
			case 2:
					AdcBuf[BufSel][BufInx++] = (USHORT)((gBufFilter[gFilIndex][i/3*2+1])& 0x0000ffff);
					break;
			default:
					break;
#endif
			}
			i++;
		}
	}

	else if(AdSamples==0){
		UsbSyncSet(BufSel,SYNC_RESET);	// c̃f[^ȂȂ̂Ńobt@J
		CommandState=0;
	}



}

//******************************************************************************
//		USBhCoƂAPI
//******************************************************************************

//******************************************************************************
//      accAdcBuf0
//******************************************************************************
LOCAL	void	accAdcBuf0(ULONG len)
{
	// AdcBuf[0] ɃANZXƂɌĂ΂܂B
	// ŃtȎȂǂsA_[Nǂoł܂B
	Flag = 1;
	SetResponse(0,0);
}

//******************************************************************************
//      accAdcBuf1
//******************************************************************************
LOCAL	void	accAdcBuf1(ULONG len)
{
	// AdcBuf[1] ɃANZXƂɌĂ΂܂B
	// ŃtȎȂǂsA_[Nǂoł܂B
	Flag = 2;
	SetResponse(0,0);
}

//******************************************************************************
//      command_interpret
//******************************************************************************
LOCAL	void	command_interpret(ULONG len)
{
	//------------------------------------------------------------
	//      obt@Commandɏ݂Ƃ̊֐Ă΂܂B
	//      obt@ɏꂽf[^̃oCg̓p[^lenœn܂B
	//      ŃR}h̉ߎs܂

	if((Command[0] == 6) && (Command[1] == 0x80)){
		AdWidth = Command[2];
		AdSamples = Command[3];
		BufSel = 0;
		BufInx = 0;

		UsbSyncSet(0,SYNC_SET);
		UsbSyncSet(1,SYNC_SET);
		Flag = 3;
		Status = 0;
		CommandState = 1;	// ADC̃f[^USBɓ]Xe[^X

		SetResponse(NORMAL,NOERROR);
	}
	else { // ȃR}h
		SetResponse(ERROR,ERR_INVALIDPARAM);
	}
	//------------------------------------------------------------
}
