/******************************************************************************
*-----------------------------------------------------------------------------
*  mcbsp_init.c
*@McBSP1SPI[hɏ邽߂̊֐
******************************************************************************/
#include "c55x_regs.h"
#include "DSP_ADC.h"


extern unsigned long gBufADC[2][DMA_BUF_SIZE];
extern unsigned int src_indx;


void spi_init(void){
	/* place the McBPS in reset */
	SPCR11 = 0;
	SPCR21 = 0;

	/* configure McBSP registers */

#if LEFT_JUSTFY
	//24bitADf[^l32rbgɓꍇF8rbgɂ0}
	SPCR11 = 0x5000;
#else
	//24bitADf[^El32rbgɓꍇF8rbg͕g
	SPCR11 = 0x3000;			//0911 Left justfy->Right
#endif
	// 0101 0000 0000 0000b
	// 0~~~ ~~~~ ~~~~ ~~~~	(DLB)
	// ~10~ ~~~~ ~~~~ ~~~~	(RJUST)		10:Left justfy
	// ~~~1 0~~~ ~~~~ ~~~~	(CLKSTP)
	// ~~~~ ~XXX ~~~~ ~~~~	Reserved
	// ~~~~ ~~~~ 0~~~ ~~~~	(DXENA)
	// ~~~~ ~~~~ ~0~~ ~~~~	Reserved  always write 0
	// ~~~~ ~~~~ ~~00 ~~~~	(RNTM)
	// ~~~~ ~~~~ ~~~~ 0~~~	(RSYNCERR)
	// ~~~~ ~~~~ ~~~~ ~0~~	(RFULL)		
	// ~~~~ ~~~~ ~~~~ ~~0~	(RRDY)
	// ~~~~ ~~~~ ~~~~ ~~~0	(RRST)
			
	SPCR21 = 0x0000;
	// 0000 0000 0000 0000b
	// XXXX XX~~ ~~~~ ~~~~	Reserved
	// ~~~~ ~~0~ ~~~~ ~~~~	(FREE)
	// ~~~~ ~~~0 ~~~~ ~~~~	(SOFT)
	// ~~~~ ~~~~ 0~~~ ~~~~	(FRST)
	// ~~~~ ~~~~ ~0~~ ~~~~	(GRST)
	// ~~~~ ~~~~ ~~00 ~~~~	(XINTM)
	// ~~~~ ~~~~ ~~~~ 0~~~	(XSYNCERR)
	// ~~~~ ~~~~ ~~~~ ~0~~	(XEMPTY)
	// ~~~~ ~~~~ ~~~~ ~~0~	(XRDY)
	// ~~~~ ~~~~ ~~~~ ~~~0	(XRST)

	RCR11 = 0x0080;
	// 0000 0000 1000 0000b
	// X~~~ ~~~~ ~~~~ ~~~~	Reserved
	// ~000 0000 ~~~~ ~~~~	(RFRLEN1)1frame
	// ~~~~ ~~~~ 100~ ~~~~	(RWDLEN1)24bit
	// ~~~~ ~~~~ ~~~X XXXX	Reserved
			
	RCR21 = 0x0001;
	// 0000 0000 0000 0001b
	// 0~~~ ~~~~ ~~~~ ~~~~	(RPHASE)
	// ~000 0000 ~~~~ ~~~~	(RFRLEN2)
	// ~~~~ ~~~~ 000~ ~~~~	(RWDLEN2)
	// ~~~~ ~~~~ ~~~0 0~~~	(RCOMPAND)
	// ~~~~ ~~~~ ~~~~ ~0~~	(RFIG)
	// ~~~~ ~~~~ ~~~~ ~~01	(RDATDLY)
			
	XCR11 = 0x0080;
	// 0000 0001 1000 0000b
	// X~~~ ~~~~ ~~~~ ~~~~	Reserved
	// ~000 0000 ~~~~ ~~~~	(XFRLEN1)1frame
	// ~~~~ ~~~~ 100~ ~~~~	(XWDLEN1)24bit
	// ~~~~ ~~~~ ~~~X XXXX	Reserved

	XCR21 = 0x0001;
	// 0000 0000 0000 0001b
	// 0~~~ ~~~~ ~~~~ ~~~~	(XPHASE)
	// ~000 0000 ~~~~ ~~~~	(XFRLEN2)
	// ~~~~ ~~~~ 000~ ~~~~	(XWDLEN2)
	// ~~~~ ~~~~ ~~~0 0~~~	(XCOMPAND)
	// ~~~~ ~~~~ ~~~~ ~0~~	(XFIG)
	// ~~~~ ~~~~ ~~~~ ~~01	(XDATDLY)

	//SPI I/F̃NbNXs[h߂iSRGR11/SRGR21)
	//ł6MHz̃NbN𐶐
	SRGR11 = 0x001f;
	// 0000 0000 0001 1111b
	// 0000 0000 ~~~~ ~~~~	(FWID)pulse width is 1bit/frame
	// ~~~~ ~~~~ 0001 1111	(CLKGDV)20clk
	//                       CLKGDV define McBSP CLKX/CLKR frequency
	//                       VC5509A:192MHz(CPU clock)->6MHz(CLKX)
	 	 
	SRGR21 = 0x2000;
	// 0010 0000 0000 0000b
	// 0~~~ ~~~~ ~~~~ ~~~~	(GSYNC)
	// ~0~~ ~~~~ ~~~~ ~~~~	(CLKSP)falling CLKX
	// ~~1~ ~~~~ ~~~~ ~~~~	(CLKSM)CLKX is driven by internal clock
	// ~~~0 ~~~~ ~~~~ ~~~~	(FSGM)FSX is generated by internal
	// ~~~~ 0000 0000 0000	(FPER)64clk per frame
	//                       FPER define FSX/FSR frequency
	//                       VC5509A:24MHz(CLKX)-> 93.75kHz(FSX)

	//PCRFMcBSP̊Os̓o͕ɐ߂郌WX^          
	PCR1 = 0x0a09;
    // 0000 1010 0000 1001b
	// X~~~ ~~~~ ~~~~ ~~~~	Reserved  read only reseved bit and returns a 0 when read
	// ~0~~ ~~~~ ~~~~ ~~~~	(IDLEEN)
	// ~~0~ ~~~~ ~~~~ ~~~~	(XIOEN)
	// ~~~0 ~~~~ ~~~~ ~~~~	(RIOEN)
	// ~~~~ 1~~~ ~~~~ ~~~~	(FSXM)
	// ~~~~ ~0~~ ~~~~ ~~~~	(FSRM)
	// ~~~~ ~~1~ ~~~~ ~~~~	(CLKXM)
	// ~~~~ ~~~0 ~~~~ ~~~~	(CLKRM)
	// ~~~~ ~~~~ 0~~~ ~~~~	(SCLKME)
	// ~~~~ ~~~~ ~0~~ ~~~~	(CLSSTAT)
	// ~~~~ ~~~~ ~~0~ ~~~~	(DXSTAT)
	// ~~~~ ~~~~ ~~~0 ~~~~	(DRSTAT)
	// ~~~~ ~~~~ ~~~~ 1~~~	(FSXP)		//FSXs̋ɐ߂
	// ~~~~ ~~~~ ~~~~ ~0~~	(FSRP)		//FSRs̋ɐ߂
	// ~~~~ ~~~~ ~~~~ ~~0~	(CLKXP)		//CLKXs̋ɐ߂
	// ~~~~ ~~~~ ~~~~ ~~~1	(CLKRP)		//CLKRs̋ɐ߂
			
}
